//	CardinalDispenser.cpp - A shot dispenser which fires along the cardinal
//							directions.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "CardinalDispenser.h"
#include "GamePlayState.h"
#include "MiscHelper.h"
#include "Tank.h"

//------------------------------------------------------------------------------
CardinalDispenser::CardinalDispenser()
{

}

//------------------------------------------------------------------------------
CardinalDispenser::~CardinalDispenser()
{

}

//------------------------------------------------------------------------------
bool CardinalDispenser::firePrimary(const Tank& tank, GamePlayState& state)
{
	int i;
	float angle = tank.getAngle() + (0.5f*NIALL_PI);
	TwoFloats dir;

	for(i=0;i<3;++i)
	{
		dir.x = -sinf(angle);
		dir.y = cosf(angle);
		state.firePrimary(tank.getPosition()+(dir*(tank.getRadius()+6.0f)),
						  dir,
						  tank.getColour(),
						  tank.getActualName());

		angle += (0.5f*NIALL_PI);
	}

	return false;
}

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
void CardinalDispenserCreator::apply(GamePlayState& state)
{
	int i;

	for(i=0;i<state.getNumTanks();++i)
	{
		if(!state.getTank(i)->getDead())
		{
			shared_ptr<PrimaryDispenser> disp(new CardinalDispenser());

			state.getTank(i)->addPrimaryDispenser(disp);
		}
	}
}
